# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class CreateMemberRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CreateMemberRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'public_key': 'str',
            'pin_public_key': 'str',
            'device': 'CreateMemberRequestDevice'
        }

        self.attribute_map = {
            'name': 'name',
            'public_key': 'publicKey',
            'pin_public_key': 'pinPublicKey',
            'device': 'device'
        }

        self._name = None
        self._public_key = None
        self._pin_public_key = None
        self._device = None

    @property
    def name(self):
        """
        Gets the name of this CreateMemberRequest.


        :return: The name of this CreateMemberRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this CreateMemberRequest.


        :param name: The name of this CreateMemberRequest.
        :type: str
        """
        self._name = name

    @property
    def public_key(self):
        """
        Gets the public_key of this CreateMemberRequest.


        :return: The public_key of this CreateMemberRequest.
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """
        Sets the public_key of this CreateMemberRequest.


        :param public_key: The public_key of this CreateMemberRequest.
        :type: str
        """
        self._public_key = public_key

    @property
    def pin_public_key(self):
        """
        Gets the pin_public_key of this CreateMemberRequest.


        :return: The pin_public_key of this CreateMemberRequest.
        :rtype: str
        """
        return self._pin_public_key

    @pin_public_key.setter
    def pin_public_key(self, pin_public_key):
        """
        Sets the pin_public_key of this CreateMemberRequest.


        :param pin_public_key: The pin_public_key of this CreateMemberRequest.
        :type: str
        """
        self._pin_public_key = pin_public_key

    @property
    def device(self):
        """
        Gets the device of this CreateMemberRequest.


        :return: The device of this CreateMemberRequest.
        :rtype: CreateMemberRequestDevice
        """
        return self._device

    @device.setter
    def device(self, device):
        """
        Sets the device of this CreateMemberRequest.


        :param device: The device of this CreateMemberRequest.
        :type: CreateMemberRequestDevice
        """
        self._device = device

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other): 
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """ 
        Returns true if both objects are not equal
        """
        return not self == other

