# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems


class GetTokenResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        GetTokenResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'account_id': 'str',
            'payee_member_id': 'str',
            'created': 'str',
            'description': 'str',
            'terms': 'GetTokenResponseTerms',
            'state': 'str'
        }

        self.attribute_map = {
            'id': 'id',
            'account_id': 'accountId',
            'payee_member_id': 'payeeMemberId',
            'created': 'created',
            'description': 'description',
            'terms': 'terms',
            'state': 'state'
        }

        self._id = None
        self._account_id = None
        self._payee_member_id = None
        self._created = None
        self._description = None
        self._terms = None
        self._state = None

    @property
    def id(self):
        """
        Gets the id of this GetTokenResponse.


        :return: The id of this GetTokenResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this GetTokenResponse.


        :param id: The id of this GetTokenResponse.
        :type: str
        """
        self._id = id

    @property
    def account_id(self):
        """
        Gets the account_id of this GetTokenResponse.


        :return: The account_id of this GetTokenResponse.
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """
        Sets the account_id of this GetTokenResponse.


        :param account_id: The account_id of this GetTokenResponse.
        :type: str
        """
        self._account_id = account_id

    @property
    def payee_member_id(self):
        """
        Gets the payee_member_id of this GetTokenResponse.


        :return: The payee_member_id of this GetTokenResponse.
        :rtype: str
        """
        return self._payee_member_id

    @payee_member_id.setter
    def payee_member_id(self, payee_member_id):
        """
        Sets the payee_member_id of this GetTokenResponse.


        :param payee_member_id: The payee_member_id of this GetTokenResponse.
        :type: str
        """
        self._payee_member_id = payee_member_id

    @property
    def created(self):
        """
        Gets the created of this GetTokenResponse.


        :return: The created of this GetTokenResponse.
        :rtype: str
        """
        return self._created

    @created.setter
    def created(self, created):
        """
        Sets the created of this GetTokenResponse.


        :param created: The created of this GetTokenResponse.
        :type: str
        """
        self._created = created

    @property
    def description(self):
        """
        Gets the description of this GetTokenResponse.


        :return: The description of this GetTokenResponse.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this GetTokenResponse.


        :param description: The description of this GetTokenResponse.
        :type: str
        """
        self._description = description

    @property
    def terms(self):
        """
        Gets the terms of this GetTokenResponse.


        :return: The terms of this GetTokenResponse.
        :rtype: GetTokenResponseTerms
        """
        return self._terms

    @terms.setter
    def terms(self, terms):
        """
        Sets the terms of this GetTokenResponse.


        :param terms: The terms of this GetTokenResponse.
        :type: GetTokenResponseTerms
        """
        self._terms = terms

    @property
    def state(self):
        """
        Gets the state of this GetTokenResponse.


        :return: The state of this GetTokenResponse.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """
        Sets the state of this GetTokenResponse.


        :param state: The state of this GetTokenResponse.
        :type: str
        """
        self._state = state

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()
